# BLUPF90 UNE Course - Lab 5
# Daniela Lourenco


#1) Run renumf90 program using renum.par parameter file to renumber the data
## As this uses the same data as yesterday, we can update the variance components
## with the values already calculated. Using sig2e = 0.6 and sig2u = 0.4 works as well

sed -i 's:0.60:0.61222:g' renum.par
sed -i 's:0.40:0.35532:g' renum.par
renumf90 renum.par | tee renum.log

#2) Calculating SNP effects in ssGBLUP: given that SNP effects are calculated based on GEBV, run blupf90+ to get solutions. 
#   Before that, check the options you will need to include in the parameter file, 
#   so blupf90+ can provide all the files needed for the calculation of SNP effects and p-values (in exercise 3). 
#   Assume that the quality control was already done (add OPTION no_quality_cotrol).

cp renf90.par ssgblup.par
echo 'OPTION no_quality_control
OPTION saveGInverse
OPTION saveA22Inverse
OPTION snp_p_value
OPTION use_yams' >> ssgblup.par

echo 'ulimit -s unlimited
export OMP_STACKSIZE=128M
blupf90+ <<AA > ssgblup.log
ssgblup.par
AA' > ssgblup.sh
bash ssgblup.sh &

#___________________________________________________________________________________________________________________________________________________#

#3) Run postGSf90 to compute p-values 
#  (the appropriate option can be found in the “preGSf90” part of the wiki). 
#  The p-values (actually, -log10(p-value) are in file chrsnp_pval. 
#  The typical threshold for detection uses the Bonferroni corrrection, which is 0.05/number_of_markers. 
#  Are there any significant markers?

cp renf90.par post.par
echo 'OPTION no_quality_control
OPTION readGInverse
OPTION readA22Inverse
OPTION snp_p_value
OPTION use_yams
OPTION windows_variance 1' >> post.par

echo 'ulimit -s unlimited
export OMP_STACKSIZE=128M
postGSf90 <<AA > post.log
post.par
AA' > post.sh
bash post.sh &

#Manhattan Plots
Rscript Vft1e2.R
Rscript Pft1e2.R
display Vft1e2_manplot.pdf
display Pft1e2_manplot.pdf


#___________________________________________________________________________________________________________________________________________________#

#4) Indirect predictions for young individuals: postGSf90 creates a file snp_pred with information about the random effects
#   (number of traits + correlated effects), the gene frequencies and the solutions of SNP effects. 
#   This is the file used by predf90 to provide indirect predictions for young genotyped animals as Za, where Z is a matrix of SNP content
#   and a is a vector of SNP effects. Run predf90 to get indirect predictions for young individuals, that were not included in the blupf90+ and postGSf90 runs. 
#   Genotypes for young animals are in a file called new_animals. 

predf90 --snpfile new_animals 
head SNP_predictions
awk '{ sumf += $3 } END { print sumf/NR }' SNP_predictions

#If want to add the pedigree base:
predf90 --snpfile new_animals --use_mu_hat
head SNP_predictions
awk '{ sumf += $3 } END { print sumf/NR }' SNP_predictions


#___________________________________________________________________________________________________________________________________________________#

